// ISDemoDlg.h : header file
//

#if !defined(AFX_ISDEMODLG_H__67F8BF49_F364_11D2_815A_444553540000__INCLUDED_)
#define AFX_ISDEMODLG_H__67F8BF49_F364_11D2_815A_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CISDemoDlg dialog

#include "_ISource.h"

class CISDemoDlg : public CDialog
{
// Construction
public:
	CISDemoDlg(CWnd* pParent = NULL);	// standard constructor

	~CISDemoDlg();

// Dialog Data
	//{{AFX_DATA(CISDemoDlg)
	enum { IDD = IDD_ISDEMO_DIALOG };
	CStatic	m_colorTextWnd;
	CStatic	m_imgRectBefore;
	CStatic	m_imgRectAfter;
	CStatic	m_histoFrame;
	BOOL	m_bBlur;
	UINT	m_uBlurLevel;
	BOOL	m_bFlipV;
	BOOL	m_bGrayscale;
	BOOL	m_bHistBlue;
	BOOL	m_bHistGreen;
	UINT	m_uHistHigh;
	UINT	m_uHistLow;
	BOOL	m_bHistRed;
	BOOL	m_bHist;
	BOOL	m_bFlipH;
	int		m_iLUTSel;
	BOOL	m_bLUTBlue;
	BOOL	m_bLUTGreen;
	BOOL	m_bLUTRed;
	BOOL	m_bLUT;
	BOOL	m_bMedianCut;
	UINT	m_uQuantColors;
	BOOL	m_bQuantize;
	BOOL	m_bRGBBGR;
	int		m_iRotateSel;
	BOOL	m_bSharpen;
	UINT	m_uSharpenLevel;
	int		m_iHistoSel;
	BOOL	m_bDespeckle;
	BOOL	m_bAutoBright;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CISDemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	CPalette m_pal;

	UINT32 m_height, m_width;
	BYTE * m_rgbBuf;

	BYTE	m_InvLUT[256];
	BYTE	m_StepLUT[256];
	
	BYTE	m_LUTChannelMask;
	BYTE		m_EQChannelMask;

	// eq graph
	BYTE		m_EQGraphMask;
	UINT32	m_EQHisto[256];

	void InvalidateAfter();
	void InvalidateBefore();
	void InvalidateHistogram();


	void MakePalette();
	void CleanUp();
	void LoadDefaultImage();
	CString StringFromErrorNum(int err);


	BYTE * RenderImage();

	// Generated message map functions
	//{{AFX_MSG(CISDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnAbout();
	afx_msg void OnSave();
	afx_msg void OnOpen();
	afx_msg void OnAutobright();
	//}}AFX_MSG
	afx_msg void UpdateInvalidate();
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ISDEMODLG_H__67F8BF49_F364_11D2_815A_444553540000__INCLUDED_)
